'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isDraggableWithin = exports.isPointWithin = undefined;

var _isWithin = require('./is-within');

var _isWithin2 = _interopRequireDefault(_isWithin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isPointWithin = exports.isPointWithin = function isPointWithin(droppable) {
  var _droppable$page$withM = droppable.page.withMargin,
      top = _droppable$page$withM.top,
      right = _droppable$page$withM.right,
      bottom = _droppable$page$withM.bottom,
      left = _droppable$page$withM.left;


  var isWithinHorizontal = (0, _isWithin2.default)(left, right);
  var isWithinVertical = (0, _isWithin2.default)(top, bottom);

  return function (point) {
    return isWithinHorizontal(point.x) && isWithinVertical(point.y);
  };
};

var isDraggableWithin = exports.isDraggableWithin = function isDraggableWithin(droppable) {
  var _droppable$page$withM2 = droppable.page.withMargin,
      top = _droppable$page$withM2.top,
      right = _droppable$page$withM2.right,
      bottom = _droppable$page$withM2.bottom,
      left = _droppable$page$withM2.left;

  var isWithinHorizontal = (0, _isWithin2.default)(left - 1, right + 1);
  var isWithinVertical = (0, _isWithin2.default)(top - 1, bottom + 1);

  return function (draggable) {
    var fragment = draggable.page.withMargin;

    return isWithinHorizontal(fragment.left) && isWithinHorizontal(fragment.right) && isWithinVertical(fragment.top) && isWithinVertical(fragment.bottom);
  };
};